{
	returncodes:
		0         : No error
		0 - 59    : Current Second
		64        : User break
}

{$M 8192,0,0}
program
	csecond;
uses
	nya;
type
	string2				=	string[2];
	string4				=	string[4];
const
	ver					:	string2 = '1';
	rev					:	string2 = '0';
	version				:	string[64] = '$VER: csecond 1.0 (6.8.95) Copyright (C)1995-96 Fredrik Wangel';
var
	y1,
	m1,
	d1,
	w1,
	j1,
	y2,
	m2						:	word;
	c1,
	c2						:	string;
	int1Bsave			:	pointer;

{$F+}
procedure _break_handler; interrupt;
	begin
		printstrln('^C');
		setvector($1B, int1Bsave);
		halt(64);
	end;
FUNCTION CursX : Byte ; ASSEMBLER;
	ASM
		MOV	AX,0300h				(* Get Cursor Position *)
		MOV	BH,0					(* Page number *)
		INT	10h
		INC	DL
		MOV	AL, DL
	END;
FUNCTION CursY : Byte ; ASSEMBLER;
	ASM
		MOV	AX,0300h				(* Get Cursor Position *)
		MOV	BH,0					(* Page number *)
		INT	10h
		INC	DH
		MOV	AL, DH
	END;
function Pad(i : word; j : byte): string4;
	begin
		Pad[0] := chr(j);
		while j > 0 do
		begin
			Pad[j] := chr(i mod 10 + ord('0'));
			i := i div 10;
			dec(j);
		end;
	end;
function Dig(i : word; j : byte) : string4;
	var
		s				:	string4;
	begin
		str(i, s);
		s := copy(s, length(s) - j + 1, j);
		while ((s[1] = '0') and (length(s) > 1)) do delete(s, 1, 1);
		dig := s;
	end;

begin
	getvector($1B, int1Bsave);
	setvector($1B, addr(_break_handler));
	if paramstr(1) = '/?' then begin
		printstrln('CSecond v' + ver + '.' + rev + ' (C)1995-96 Fredrik Wangel');
		printstrln('Usage: CSecond');
		setvector($1B, int1Bsave);
		halt(0);
	end;
	if paramstr(1) = '/!' then begin
		printstrln('        CSecond v' + ver + '.' + rev + ' (C)1995-96 Fredrik Wangel');
		printstrln('');
		printstrln('CSecond  returns the  current  amount of seconds.  The');
		printstrln('return code  is set to the  current second so that you');
		printstrln('test it in a batchfile.');
		printstrln('You can redirect  the output using the standard MS-DOS');
		printstrln('output redirection character ( > ).  For  instance  to');
		printstrln('output to  the printstrer  you would type "CSECOND >prn".');
		printstrln('');
		setvector($1B, int1Bsave);
		halt(0);
	end;
	XGetTime(y1, m1, d1, w1);
	if cursx <> 1 then printstrln('');
	printstrln(dig(d1, 2));
	setvector($1B, int1Bsave);
	halt(d1);
end.
