{
	returncodes:
		0         : No error
		1         : User break
}

{$M 8192,0,0}
program
	ctime;
uses
	intl,
	nya;
type
	string2				=	string[2];
	string4				=	string[4];
const
	ver					:	string2 = '1';
	rev					:	string2 = '0';
	version				:	string[64] = '$VER: ctime 1.0 (5.8.95) Copyright (C)1995-96 Fredrik Wangel';
	ampm					:	array[1..2] of string2 = ('am', 'pm');
var
	y1,
	m1,
	d1,
	w1,
	j1,
	y2,
	m2						:	word;
	c1,
	c2						:	string;
	int1Bsave			:	pointer;

{$F+}
procedure _break_handler; interrupt;
	begin
		printstr('^C');
		setvector($1B, int1Bsave);
		halt(1);
	end;
FUNCTION CursX : Byte ; ASSEMBLER;
	ASM
		MOV	AX,0300h				(* Get Cursor Position *)
		MOV	BH,0					(* Page number *)
		INT	10h
		INC	DL
		MOV	AL, DL
	END;
FUNCTION CursY : Byte ; ASSEMBLER;
	ASM
		MOV	AX,0300h				(* Get Cursor Position *)
		MOV	BH,0					(* Page number *)
		INT	10h
		INC	DH
		MOV	AL, DH
	END;
function Pad(i : word; j : byte): string4;
	begin
		Pad[0] := chr(j);
		while j > 0 do begin
			Pad[j] := chr(i mod 10 + ord('0'));
			i := i div 10;
			dec(j);
		end;
	end;
function Dig(i : word; j : byte) : string4;
	var
		s				:	string4;
	begin
		str(i, s);
		s := copy(s, length(s) - j + 1, j);
		while ((s[1] = '0') and (length(s) > 1)) do
			delete(s, 1, 1);
		dig := s;
	end;

begin
	getvector($1B, int1Bsave);
	setvector($1B, addr(_break_handler));
	if paramstr(1) = '/?' then begin
		printstrln('CTime v' + ver + '.' + rev + ' (C)1995-96 Fredrik Wangel');
		printstrln('Usage: CTime [[/12] | [timeformat]]');
		setvector($1B, int1Bsave);
		halt(0);
	end;
	if paramstr(1) = '/!' then begin
		printstrln('         CTime v' + ver + '.' + rev + ' (C)1995-96 Fredrik Wangel');
		printstrln('');
		printstrln('CTime  returns the  current  time  in a user definable');
		printstrln('format  by  using a  combination  of %H, %M, %S and %C');
		printstrln('as well as other characters to personalize the output.');
		printstrln('   %H outputs the hour without padding.');
		printstrln('  %HH outputs the hour with zeropadding.');
		printstrln(' %H12 is like %H but uses 12-hour clock.');
		printstrln('%HH12 12-hour clock with zeropadding.');
		printstrln('   %T is like %H12 but adds either AM or PM.');
		printstrln('  %TT is like %TT but with zeropadding.');
		printstrln('   %M works in the same way as %H but outputs minutes.');
		printstrln('  %MM is like %M but with zeropadding.');
		printstrln('   %S returns seconds and works like the %M.');
		printstrln('  %SS zeropadded.');
		printstrln('   %C outputs hundredths of seconds.');
		printstrln('  %CC has zeropadding.');
		printstrln('   %P outputs either AM or PM depending on the hour.');
		printstrln('   %% returns the % character.');
		printstrln('If you give  /12  as the only parameter,  then a short');
		printstrln('version  of the  time is  given  in a 12 hour  format.');
		printstrln('You can redirect  the output using the standard MS-DOS');
		printstrln('output redirection character ( > ).  For  instance  to');
		printstrln('output to  the printstrer  you would  type  "CTIME >prn".');
		printstrln('');
		setvector($1B, int1Bsave);
		halt(0);
	end;
	XGetTime(y1, m1, d1, w1);
	if y1 > 12 then
		j1 := y1 - 12
	else
		j1 := y1;
	if y1 = 0 then
		j1 := 12;
	if ((paramcount = 0) or (paramstr(1) = '/12')) then begin
		if cursx <> 1 then
			printstrln('');
		if y1 >= 12 then
			c2 := ampm[2]
		else
			c2 := ampm[1];
		if paramstr(1) = '/12' then
			printstrln(dig(j1, 2) + ':' + pad(m1, 2) + c2)
		else
			printstrln(pad(y1, 2) + ':' + pad(m1, 2) + '.' + pad(d1, 2));
		setvector($1B, int1Bsave);
		halt(0);
	end;
	c1 := '';
	y2 := paramcount;
	for m2 := 1 to y2 do
		c1 := c1 + paramstr(m2) + ' ';
	c1[length(c1)] := #3;
	c2 := '';
	y2 := 0;
	repeat
		inc(y2);
		if c1[y2] = '%' then begin
			c1[y2] := #2;
			if c1[y2 + 1] = '%' then begin
				c2 := c2 + '%';
				delete(c1, y2, 2);
				dec(y2);
			end
			else
			if ucasestrintl(copy(c1, y2 + 1, 4)) = 'HH12' then begin
				c2 := c2 + pad(j1, 2);
				delete(c1, y2, 5);
				dec(y2);
			end
			else
			if ucasestrintl(copy(c1, y2 + 1, 3)) = 'H12' then begin
				c2 := c2 + dig(j1, 2);
				delete(c1, y2, 4);
				dec(y2);
			end
			else
			if ucasestrintl(copy(c1, y2 + 1, 2)) = 'TT' then begin
				c2 := c2 + pad(j1, 2);
				if y1 >= 12 then
					c2 := c2 + ampm[2]
				else
					c2 := c2 + ampm[1];
				delete(c1, y2, 3);
				dec(y2);
			end
			else
			if ucasestrintl(c1[y2 + 1]) = 'T' then begin
				c2 := c2 + dig(j1, 2);
				if y1 >= 12 then
					c2 := c2 + ampm[2]
				else
					c2 := c2 + ampm[1];
				delete(c1, y2, 2);
				dec(y2);
			end
			else
			if ucasestrintl(c1[y2 + 1]) = 'P' then begin
				if y1 >= 12 then
					c2 := c2 + ampm[2]
				else
					c2 := c2 + ampm[1];
				delete(c1, y2, 2);
				dec(y2);
			end
			else
			if ucasestrintl(copy(c1, y2 + 1, 2)) = 'HH' then begin
				c2 := c2 + pad(y1, 2);
				delete(c1, y2, 3);
				dec(y2);
			end
			else
			if ucasestrintl(c1[y2 + 1]) = 'H' then begin
				c2 := c2 + dig(y1, 2);
				delete(c1, y2, 2);
				dec(y2);
			end
			else
			if ucasestrintl(copy(c1, y2 + 1, 2)) = 'MM' then begin
				c2 := c2 + pad(m1, 2);
				delete(c1, y2, 3);
				dec(y2);
			end
			else
			if ucasestrintl(c1[y2 + 1]) = 'M' then begin
				c2 := c2 + dig(m1, 2);
				delete(c1, y2, 2);
				dec(y2);
			end
			else
			if ucasestrintl(copy(c1, y2 + 1, 2)) = 'SS' then begin
				c2 := c2 + pad(d1, 2);
				delete(c1, y2, 3);
				dec(y2);
			end
			else
			if ucasestrintl(c1[y2 + 1]) = 'S' then begin
				c2 := c2 + dig(d1, 2);
				delete(c1, y2, 2);
				dec(y2);
			end
			else
			if ucasestrintl(copy(c1, y2 + 1, 2)) = 'CC' then begin
				c2 := c2 + pad(d1, 2);
				delete(c1, y2, 3);
				dec(y2);
			end
			else
			if ucasestrintl(c1[y2 + 1]) = 'C' then begin
				c2 := c2 + dig(d1, 2);
				delete(c1, y2, 2);
				dec(y2);
			end;
		end
		else
			c2 := c2 + c1[y2];
	until c1[y2] = #3;
	c2[0] := chr(ord(c2[0]) - 1);
	if cursx <> 1 then
		printstrln('');
	printstrln(c2);
	setvector($1B, int1Bsave);
	halt(0);
end.
