{
	returncodes:
		0         : No error
		1 - 7     : Current Weekday
		64        : User break
}

{$M 8192,0,0}
program
	cweekday;
uses
	intl,
	nya;
type
	string2				=	string[2];
	string4				=	string[4];
const
	ver					:	string2 = '1';
	rev					:	string2 = '0';
	version				:	string[64] = '$VER: cweekday 1.0 (6.8.95) Copyright (C)1995-96 Fredrik Wangel';
	days					:	array[0..6] of string[16] = ('Sunday', 'Monday', 'Tuesday', 'Wednesday',
																	  'Thursday', 'Friday', 'Saturday');
var
	y1,
	m1,
	d1,
	w1,
	j1,
	y2,
	m2						:	word;
	c2						:	string;
	int1Bsave			:	pointer;

{$F+}
procedure _break_handler; interrupt;
	begin
		println('^C');
		setvector($1B, int1Bsave);
		halt(64);
	end;
procedure XGetDate(var year, mon, day, dow : word); assembler;
	asm
		mov	ah, 42
		int	33
		mov	bx, ax
		les	di, year
		mov	word ptr es:[di], cx
		mov	ax, dx
		and	ax, $ff00
		shr	ax, 8
		les	di, mon
		mov	word ptr es:[di], ax
		mov	ax, dx
		and	ax, $00ff
		les	di, day
		mov	word ptr es:[di], ax
		mov	ax, bx
		and	ax, $00ff
		les	di, dow
		mov	word ptr es:[di], ax
	end;
FUNCTION CursX : Byte ; ASSEMBLER;
	ASM
		MOV	AX,0300h				(* Get Cursor Position *)
		MOV	BH,0					(* Page number *)
		INT	10h
		INC	DL
		MOV	AL, DL
	END;
FUNCTION CursY : Byte ; ASSEMBLER;
	ASM
		MOV	AX,0300h				(* Get Cursor Position *)
		MOV	BH,0					(* Page number *)
		INT	10h
		INC	DH
		MOV	AL, DH
	END;
function Pad(i : word; j : byte): string4;
	begin
		Pad[0] := chr(j);
		while j > 0 do
		begin
			Pad[j] := chr(i mod 10 + ord('0'));
			i := i div 10;
			dec(j);
		end;
	end;
function Dig(i : word; j : byte) : string4;
	var
		s				:	string4;
	begin
		str(i, s);
		s := copy(s, length(s) - j + 1, j);
		while ((s[1] = '0') and (length(s) > 1)) do delete(s, 1, 1);
		dig := s;
	end;

begin
	getvector($1B, int1Bsave);
	setvector($1B, addr(_break_handler));
	if paramstr(1) = '/?' then begin
		printstrln('cweekday v' + ver + '.' + rev + ' (C)1995-96 Fredrik Wangel');
		printstrln('Usage: cweekday [[/S]|[/N]]');
		setvector($1B, int1Bsave);
		halt(0);
	end;
	if paramstr(1) = '/!' then begin
		printstrln('        CWeekday v' + ver + '.' + rev + ' (C)1995-96 Fredrik Wangel');
		printstrln('');
		printstrln('CWeekday returns the current day of the week.  The way');
		printstrln('it shows it  depends on  the parameters.  No parameter');
		printstrln('gives you the full name of the day. A /S gives you the');
		printstrln('short  version (ie three  characters)  and /N presents');
		printstrln('the  number of  the day (1 = Sunday,  2 = Monday etc).');
		printstrln('The return code is set to  that number so that you can');
		printstrln('test it in a batchfile.');
		printstrln('You can redirect  the output using the standard MS-DOS');
		printstrln('output redirection character ( > ).  For  instance  to');
		printstrln('output to  the printer you would type "CWEEKDAY >prn".');
		printstrln('');
		setvector($1B, int1Bsave);
		halt(0);
	end;
	XGetDate(y1, m1, d1, w1);
	if cursx <> 1 then printstrln('');
	c2 := paramstr(1);
	if ucasestrintl(c2) = '/S' then begin
		printstrln(copy(days[w1], 1, 3));
	end;
	if ucasestrintl(c2) = '/N' then begin
		printstrln(dig(w1 + 1, 2));
	end;
	if paramcount = 0 then begin
		printstrln(days[w1]);
	end;
	setvector($1B, int1Bsave);
	halt(w1);
end.
