;NUMB
;switches the state of the Num Lock
;Fredrik Wangel, 06.11.95

CSEG     SEGMENT  PUBLIC PARA
         ASSUME   CS:CSEG, DS:CSEG, ES:CSEG

         ORG   100h                       ; Fr att kunna gra till .COM fil.

         MOV   AX, 0040h                  ; Segment $0040
         MOV   ES, AX                     ;
         MOV   SI, ES:[0017h]             ; Offset $0017
         TEST  SI, 0020h                  ; r [$0040:$0017] = 32 ?
         JZ    not_on                     ; Nej, hoppa till not_on
         ADD   SI, -20h                   ; Minska vrdet med 32
         MOV   DI, OFFSET off$            ; Stt pekare till "av" strngen
         MOV   AL, 00h                    ; ExitCode = 0
         JMP   set_num                    ; Hoppa till set_num
                                          ;
not_on:  ADD   SI, +20h                   ; ka vrdet med 32
         MOV   DI, OFFSET on$             ; Stt pekare till "p" strngen
         MOV   AL, 01h                    ; ExitCode = 1
                                          ;
set_num: MOV   ES:[0017h], SI             ; Lagra nya vrdet
                                          ;
         PUSH  AX                         ; Spara ExitCode
                                          ;
         MOV   SI, OFFSET pad$            ; Pekare till tom strng
nextc:   MOV   CL, [DI]                   ; Ta fram nsta tecken i av/p strngen
         CMP   CL, 0FFh                   ; Jmfr med $FF
         JE    print                      ; Det var $FF, hoppa till print
         MOV   [SI], CL                   ; Lagra tecken i tomma strngen
         INC   SI                         ; ka teckenpekare
         INC   DI                         ; Samma hr
         JMP   nextc                      ; G tillbaka till nextc
                                          ;
print:                                    ;
         MOV   DX, OFFSET nmsg$           ; Pekare till "Numlock is..." strng
         MOV   AH, 09h                    ; DOS Print $-string
         INT   21h                        ; Anropa DOS funktionen
         POP   AX                         ; Exitcode
         MOV   AH, 4Ch                    ; DOS Terminate program
         INT   21h                        ; Anropa
                                          ;
;Data area
nmsg$    DB    'NumLock is now'                             ; 14 tecken
pad$     DB    ''                                 ; 10 tecken
on$      DB    ' on.', 13, 10, '$', 32, 32, 32, 0FFh     ; 10 tecken + $FF
off$     DB    ' off.',    13, 10, '$', 32, 32, 0FFh     ; 10 tecken + $FF
cpy$     DB    '$VER: Numb 1.0 (06.11.95) '
         DB    'Copyright (C)1995 Fredrik Wangel', 00

CSEG     ENDS
         END
