{ Copyright (c) 1993-95 av Fredrik Wangel }
{ v1.06 16.7.93 : First workable version }
{ v2.00 17.9.95 : Major rewrite of some routines. Now .ini file is in .exe
						and no .$$$ files are created }
program _timeout;
{$M 8192,0,0}
uses
	writexec,
	nya,
	dos,
	crt;
const
	otc				:	word = yellow;
	obc				:	word = cyan;
	orc				:	word = white;
	oinfo				:	string = '';
	utc				:	word = yellow;
	ubc				:	word = cyan;
	urc				:	word = white;
	uinfo				:	string = '';
	verstr			:	string = 'TIMEOUTX v2.01 (28.1.96)';
	copstr			:	string = 'Copyright (c)1993-96 Fredrik Wangel';
	sbx				=	1;
	sbx2				=	64;
	sby				=	1;
	sby2				=	8;
	islen				=	sbx2 - 4;
type
	artyp				=	array[0..3999] of word;
var
	regs				:	registers;
	minne				:	artyp;
	a					:	artyp ABSOLUTE $B800:$0000;
	vidmem			:	artyp ABSOLUTE minne;
	parstr			:	string[127];
	command			:	string[127];
	infostr			:	string[islen + 1];
	rf,
	tc,
	bc,
	rc,
	old_x,
	old_y,
	gta				:	word;
	bol				:	boolean;
	bx,
	bx2,
	by,
	by2,
	tbx,
	tbx2,
	tby,
	tby2,
	i					:	integer;
	flum				:	byte;
	int1Bsave		:	pointer;

{$F+}
procedure _break_handler; interrupt;
	begin
	end;
{$F-}

PROCEDURE _Spara_Skarm;
	BEGIN
		Move(a, vidmem, SizeOf(a));
	END;

PROCEDURE _Visa_Skarm;
	VAR
		x,
		y		: integer;
	BEGIN
		for x := 1 to (4 * (lo(windmax) + 1) * (hi(windmax) + 1)) do begin
			y := random((lo(windmax) + 1) * (hi(windmax) + 1));
			a[y] := vidmem[y];
		end;
		Move(vidmem, a, SizeOf(vidmem));
	END;

function _numstr(nstrn, nstrd: longint): string;
	var
		minus					:	boolean;
		nstrsta				:	string;
	begin
		minus := false;
		if nstrn < 0 then
			minus := true;
		nstrn := abs(nstrn);
		nstrsta[0] := chr(nstrd);
		while nstrd > 0 do
		begin
			nstrsta[nstrd] := chr(nstrn mod 10 + ord('0'));
			nstrn := nstrn div 10;
			dec(nstrd);
		end;
		if minus = true then
			nstrsta := '-' + nstrsta;
		_numstr := nstrsta;
	end;

procedure _centrera(cns : string; cnr, cnta : integer);
var
	cnsf				:	integer;
begin
	cnsf := textattr;
	gotoxy((((lo(windmax) + 1) div 2) - (length(cns) div 2)), cnr);
	textattr := cnta;
	write(cns);
	textattr := cnsf;
end;

procedure _reset_pos;
begin
	gotoxy(old_x, old_y);
end;

procedure _save_pos;
begin
	old_x := wherex;
	old_y := wherey;
end;

procedure _change_line(x1, x2, y : integer ; chrattr : word);
var
	ks						,
	ps						:	integer;
begin
	ks := (lo(windmax) + 1) * (y - 1);
	for ps := (x1 + ks - 1) to (x2 + ks - 1) do
	begin
		a[ps] := chrattr;
	end;
end;

procedure _change_line2(x1, x2, y : integer ; chrattr : word);
var
	ks						,
	ps						:	integer;
begin
	ks := (lo(windmax) + 1) * (y - 1);
	for ps := (x1 + ks - 1) to (x2 + ks - 1) do
	begin
		a[ps] := lo(a[ps]) xor chrattr;
	end;
end;

procedure _centrera2(cex, cex2, cey : integer ; ces : string; tf : word);
var
	ceja				:	integer;
begin
	ces := copy(ces, 1, (cex2 - cex - 9));
	ceja := cex + (((cex2 - cex) div 2) - (length(ces) div 2));
	gotoxy(ceja, cey);
	ceja := textattr;
	textcolor(tf);
	textbackground(bc);
	write(ces);
	textattr := ceja;
end;

procedure _make_box(mbx, mby, mbx2, mby2 : integer ; mbs : string);
var
	mbja				:	integer;
begin
	for mbja := mby + 1 to mby2 - 1 do
	begin
		_change_line(mbx + 1, mbx2 - 1, mbja, rf + $0020);
	end;
	_change_line(mbx, mbx, mby, rf + $00c9);
	_change_line(mbx + 1, mbx2 - 1, mby, rf + $00cd);
	_change_line(mbx2, mbx2, mby, rf + $00bb);
	for mbja := mby + 1 to mby2 do
	begin
		_change_line(mbx, mbx, mbja, rf + $00ba);
		_change_line(mbx2, mbx2, mbja, rf + $00ba);
		_change_line2(mbx2 + 1, mbx2 + 2, mbja, $0800);
	end;
	_change_line(mbx, mbx, mby2, rf + $00c8);
	_change_line(mbx + 1, mbx2 - 1, mby2, rf + $00cd);
	_change_line(mbx2, mbx2, mby2, rf + $00bc);
	_change_line2(mbx + 2, mbx2 + 2, mby2 + 1, $0800);
	_centrera2(mbx, mbx2, mby, mbs, tc);
end;

procedure _sound(hz, dur : word);
	begin
		if (hz > 36) and (hz < 30001) then
			buzz(hz);
		delay(dur);
		quiet;
	end;

procedure _exec(exco : string);
	var
		exs			:	pathstr;
	begin
		swapvectors;
		exec(getenv('COMSPEC'), '/C ' + exco);
		swapvectors;
		if doserror <> 0 then
		begin
			exs := fsearch('COMMAND.COM', getenv('PATH'));
			swapvectors;
			exec(fexpand(exs), '/C ' + exco);
			swapvectors;
		end;
	end;

procedure _load_setup;
	begin
		tc := utc;
		bc := ubc;
		rc := urc;
		infostr := uinfo;
		rf := (bc * $1000) + (rc * $100);
	end;

procedure _helpuser;
	begin
		writeln('Gives the user 10 seconds to abort the execution of a command.');
		writeln;
		writeln('TIMEOUTX [/?] [/!] [/P] [commandline]');
		writeln;
		writeln('  /!           Shows information about the program.');
		writeln('  /P           Only start setup screen.');
		writeln('  commandline  The command to be called and arguments to it if any.');
		setintvec($1B, int1Bsave);
		halt(0);
	end;

procedure _informuser;
	begin
		writeln(verstr);
		writeln(copstr);
		writeln('Freely distributable.');
		setintvec($1B, int1Bsave);
		halt(0);
	end;

procedure _redraw2(rdi2 : integer);
	begin
		_centrera2(bx, bx2, by +  2, '  Textcolor        ', tc);
		_centrera2(bx, bx2, by +  3, '  Backgroundcolor  ', tc);
		_centrera2(bx, bx2, by +  4, '  Bordercolor      ', tc);
		_centrera2(bx, bx2, by +  5, '  Information text ', tc);

		_centrera2(bx, bx2, by +  6, #39 + infostr + #39, rc);

		_centrera2(bx, bx2, by +  8, 'Use the arrow keys to adjust the settings.', rc);
		_centrera2(bx, bx2, by + 10, '['#30'] Goes upwards in the menu.     ', rc);
		_centrera2(bx, bx2, by + 11, '['#31'] Goes downwards in the menu.   ', rc);
		_centrera2(bx, bx2, by + 12, '['#17'] Increases color.              ', rc);
		_centrera2(bx, bx2, by + 13, '['#16'] Decreases color.              ', rc);

		_centrera2(bx, bx2, by + 15, '[S] Saves settings in the .EXE file.     ', tc);
		_centrera2(bx, bx2, by + 16, '[L] Load last saved settings.            ', tc);
		_centrera2(bx, bx2, by + 17, '[R] Resets to default settings.          ', tc);
		_centrera2(bx, bx2, by + 18, '[U] Undo last change.                    ', tc);

		case rdi2 of
			1:	_centrera2(bx, bx2, by + 2, #9' TEXTCOLOR        ', tc);
			2:	_centrera2(bx, bx2, by + 3, #9' BACKGROUNDCOLOR  ', tc);
			3:	_centrera2(bx, bx2, by + 4, #9' BORDERCOLOR      ', tc);
			4:	_centrera2(bx, bx2, by + 5, #9' INFORMATION TEXT ', tc);
		end;
	end;

procedure _redraw(rdi : integer);
	begin
		rf := (bc * $1000) + (rc * $100);
		_make_box(bx, by, bx2, by2, ' Time-OutX v2.00 SETUP ');
		_redraw2(rdi);
	end;

procedure _cleanup;
	begin
		_reset_pos;
		_Visa_Skarm;
		textattr := gta;
	end;

function _input(ins : string ; inl : byte) : string;
	var
		inch				:	char;
		instmp			:	string;
		ini				:	integer;
	begin
		instmp := ins;
		inch := #0;
		ini := length(instmp) + 1;
		textattr := $07;
		_change_line(bx + 3, bx2 - 3, by + 6, $0720);
		gotoxy(bx + 3, wherey);
		write(instmp);
		gotoxy(bx + 2 + ini, wherey);
		repeat
			inch := readkey;
			if (inch = #8) and (ini >= 1) then
			begin
				delete(instmp, ini - 1, 1);
				_change_line(bx + 3, bx2 - 3, by + 6, $0720);
				gotoxy(bx + 3, wherey);
				write(instmp);
				dec(ini);
				if ini<1 then
					ini:=1;
				gotoxy(bx + 2 + ini, wherey);
			end
			else
			begin
				if (inch <> #13) and (inch <> #27) then
				begin
					if ord(inch) <> 0 then
					begin
						if length(instmp) <= inl then
						begin
							insert(inch, instmp, ini);
							_change_line(bx + 3, bx2 - 3, by + 6, $0720);
							gotoxy(bx + 3, wherey);
							write(instmp);
							inc(ini);
							gotoxy(bx + 2 + ini, wherey);
						end;
					end
					else
					begin
						inch := readkey;
						if inch = #75 then
						begin
							dec(ini);
							if ini < 1 then ini := 1;
						end;
						if inch = #77 then
						begin
							inc(ini);
							if ini > (length(instmp) + 1) then ini := (length(instmp) + 1);
						end;
						if inch = #71 then
						begin
							ini := 1;
						end;
						if inch = #79 then
						begin
							ini := (length(instmp) + 1);
						end;
						_change_line(bx + 3, bx2 - 3, by + 6, $0720);
						gotoxy(bx + 3, wherey);
						write(instmp);
						gotoxy(bx + 2 + ini, wherey);
					end;
				end;
			end;
		until (inch = #27) or (inch = #13);
		if inch = #27 then
			_input := ins
		else
		begin
			_input := instmp;
		end;
	end;

procedure _usersetup;
	var
		usc				:	char;
		usi				:	integer;
		gatc,
		gabc,
		garc,
		gatc2,
		gabc2,
		garc2				:	word;
	begin
		bx  := ((lo(windmax) + 1) div 2) - (sbx2 div 2) - 1;
		bx2 := bx + sbx2;
		by  := ((hi(windmax) + 1) div 2) - (sby2 div 2) - 1;
		by2 := by + sby2;
		 by := by - 4;
		by2 := by2 + 8;
		usc := #0;
		usi := 1;
		_redraw(usi);
		gatc := tc;
		gabc := bc;
		garc := rc;
		repeat
			usc := readkey;
			if usc = #0 then
			begin
				usc := readkey;
				if usc = #75 then
				begin
					gatc := tc;
					gabc := bc;
					garc := rc;
					case usi of
						1:	begin
								dec(tc);
								tc := tc mod 16;
								if bc = tc then
								begin
									dec(tc);
									tc := (tc mod 16);
								end;
							end;
						2:	begin
								dec(bc);
								bc := bc mod 8;
								if bc = tc then
								begin
									dec(bc);
									bc := (bc mod 8);
								end;
								if bc = rc then
								begin
									dec(bc);
									bc := (bc mod 8);
								end;
							end;
						3:	begin
								dec(rc);
								rc := rc mod 16;
								if bc = rc then
								begin
									dec(rc);
									rc := (rc mod 16);
								end;
							end;
					end;
					_redraw(usi);
				end;
				if usc = #77 then
				begin
					gatc := tc;
					gabc := bc;
					garc := rc;
					case usi of
						1:	begin
								tc := (tc + 1) mod 16;
								if bc = tc then
								begin
									inc(tc);
									tc := (tc mod 16);
								end;
							end;
						2:	begin
								bc := (bc + 1) mod 8;
								if bc = tc then
								begin
									inc(bc);
									bc := (bc mod 8);
								end;
								if bc = rc then
								begin
									inc(bc);
									bc := (bc mod 8);
								end;
							end;
						3:	begin
								rc := (rc + 1) mod 16;
								if bc = rc then
								begin
									inc(rc);
									rc := (rc mod 16);
								end;
							end;
					end;
					_redraw(usi);
				end;
				if usc = #80 then
				begin
					usi := ((usi + 4) mod 4) + 1;
					_redraw2(usi);
				end;
				if usc = #72 then
				begin
					usi := ((usi + 2) mod 4) + 1;
					_redraw2(usi);
				end;
			end
			else
			begin
				if (usc = #13) and (usi = 4) then
				begin
					_change_line(bx + 3, bx2 - 3, by + 6, $0720);
					gotoxy(bx + 3, by + 6);
					infostr := _input(infostr, islen);
					_change_line(bx + 3, bx2 - 3, by + 6, rf + $0020);
					_redraw2(usi);
				end;
				if upcase(usc) = 'U' then
				begin
					gatc2 := tc;
					gabc2 := bc;
					garc2 := rc;
					tc := gatc;
					bc := gabc;
					rc := garc;
					gatc := gatc2;
					gabc := gabc2;
					garc := garc2;
					_redraw(usi);
				end;
				if upcase(usc) = 'R' then
				begin
					gatc := tc;
					gabc := bc;
					garc := rc;
					tc := otc;
					bc := obc;
					rc := orc;
					_redraw(usi);
				end;
				if upcase(usc) = 'L' then
				begin
					gatc := tc;
					gabc := bc;
					garc := rc;
					_load_setup;
					_redraw(usi);
				end;
				if upcase(usc) = 'S' then
				begin
					utc := tc;
					ubc := bc;
					urc := rc;
					uinfo := infostr;
					WriteToExecutable(utc, SizeOf(utc));
					WriteToExecutable(ubc, SizeOf(ubc));
					WriteToExecutable(urc, SizeOf(urc));
					WriteToExecutable(uinfo, SizeOf(uinfo));
					_redraw(usi);
				end;
			end;
		until usc = #27;
		bx  := ((lo(windmax) + 1) div 2) - (sbx2 div 2) - 1;
		bx2 := bx + sbx2;
		by  := ((hi(windmax) + 1) div 2) - (sby2 div 2) + 1;
		by2 := by + sby2;
		if infostr <> '' then
		begin
			dec(by2);
		end;
		textattr := gta;
	end;

procedure _toscreen;
	begin
		bx  := ((lo(windmax) + 1) div 2) - (sbx2 div 2) - 1;
		bx2 := bx + sbx2;
		by  := ((hi(windmax) + 1) div 2) - (sby2 div 2) + 1;
		by2 := by + sby2;

		if infostr <> '' then
		begin
			dec(by2, 2);
			dec(by);
		end;

		_make_box(bx, by, bx2, by2, '');		(* 'Time-OutX v2.00' *)

		if infostr = '' then
		begin
			_centrera2(bx, bx2, by + 2, 'About to execute the command:', tc);
			_centrera2(bx, bx2, by + 3, #39 + command + #39, rc);
			flum := 1;
		end
		else
		begin
			_centrera2(bx, bx2, by + 2, infostr, rc);
			flum := 0;
		end;

		_centrera2(bx, bx2, by + 4 + flum, '  Abort by pressing any acceptable key within  10 sec.', tc);
		_centrera2(bx, bx2, by + 5 + flum, 'Press [P] for preferences.', rc);
	end;

function _cut_it_out(cios : string ; ciowx, ciowx2, cioy : integer) : boolean;
	label
		cio_label_one,
		cio_label_two;
	var
		uc					:	char;
		seco,
		oldseco,
		uh,
		um,
		us,
		us100,
		uh2,
		um2,
		us2,
		us1002			:	word;
		utmp				:	longint;
	begin
		_centrera2(ciowx, ciowx2, by + 4 + flum, cios, tc);
		textcolor(tc);
		textbackground(bc);
		gettime(uh, um, us, us100);
		seco := 0;
		oldseco := 0;
		cio_label_one:
		uc := #0;
		repeat
			gettime(uh2, um2, us2, us1002);
			utmp := 0;
			{$I-}
			utmp := us2 - us;
			{$I+}
			if utmp < 61 then
				seco := us2 - us
			else
				seco := 60 - (65536 - (abs(us2 - us)));
			if (oldseco <> seco) and ((us1002 >= 0) and (us1002 <= 5)) then
			begin
				_sound(1000, 1);
				oldseco := seco;
				gotoxy(wherex - 7, by + 4 + flum);
				write(_numstr(10 - seco, 2), ' sec.');
			end;
		until (keypressed) or (seco >= 10);
		if seco >= 10 then
			_cut_it_out := true
		else
		begin
			_cut_it_out := false;
			uc := readkey;
			if ord(uc) = 0 then
			begin
				uc := readkey;
			end
			else
			begin
				if ucase(uc) = 'P' then
				begin
					_usersetup;
					_reset_pos;
					_visa_skarm;
					_toscreen;
					_centrera2(ciowx, ciowx2, by + 4 + flum, cios, tc);
					textcolor(tc);
					textbackground(bc);
					gettime(uh, um, us, us100);
					seco := 0;
					oldseco := 0;
					goto cio_label_one;
				end
				else
				begin
					_cut_it_out := false;
					goto cio_label_two;
				end;
			end;
			goto cio_label_one;
		end;
		cio_label_two:
	end;



Begin
	getintvec($1B, int1Bsave);
	setintvec($1B, addr(_break_handler));
	gta := textattr;
	tc  := otc;
	bc  := obc;
	rc  := orc;
	infostr := '';
	_load_setup;
	_spara_skarm;
	_save_pos;
	randomize;
	command := '';
	if paramcount > 0 then
	begin
		for i := 1 to paramcount do
		begin
			parstr := paramstr(i);
			if parstr = '/?' then
				_helpuser;
			if parstr = '/!' then
				_informuser;
			if ucasestr(parstr) = '/P' then
			begin
				_usersetup;
				_cleanup;
				setintvec($1B, int1Bsave);
				halt(0);
			end;
			command := command + parstr + ' ';
		end;
	end;
	if length(command) > 0 then
		delete(command, length(command), 1);
{
	if command = '' then
	begin
		writeln('You must state a command!');
		setintvec($1B, int1Bsave);
		halt(0);
	end;
}
	_toscreen;
	bol := _cut_it_out('  Abort by pressing any acceptable key within  10 sec.', bx, bx2, by + 4 + flum);
	_cleanup;
	setintvec($1B, int1Bsave);
	if bol = true then
		_exec(command);
End.
