#include <io.h>
#include <dir.h>
#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <iostream.h>

const char ver[] = "$VER: cwd 1.00 (29.4.96) copyright (c)1996 Fredrik Wangel";

void getcd()
{
	char buffer[MAXPATH];
	getcwd(buffer, MAXPATH);
	cout << buffer << endl;
}

void setcd(char *dir)
{
	char path[MAXPATH];
	if(!*dir)
		cin.get(path, MAXPATH, '\n');
	else
		strcpy(path, dir);
	if(path[1] == ':' && path[2] == '\0')
		strcat(path, ".");
	if(chdir(path))
		cerr << "error changing directory" << endl;
	if(path[1] == ':')
		setdisk(toupper(path[0]) - 'A');

}

int main(int argc, char *argv[])
{
	argc--;

	int handle = fileno(stdin);
	if(!isatty(handle))
		setcd('\0');
	else if(!argc)
		getcd();
	else if(strstr(argv[1], "?"))
		cout << "cwd 1.00 copyright (c) 1996 Fredrik Wangel" << endl << endl
			  << "usage: cwd dir" << endl << endl
			  << "  cwd gets or sets the current work directory" << endl
			  << "  use redirection to  get or set  current dir" << endl
			  << "  to/from a file. cwd with no parameters will" << endl
			  << "  return current dir, if the input stream has" << endl
			  << "  not been redirected, in which case cwd will" << endl
			  << "  read from that file and set cd accordingly." << endl
			  << "  this is also true  if a directory  is given" << endl
			  << "  as a command line parameter." << endl
			  << "  eg. cwd c:\\dos" << endl
			  << "      cwd < c:\\temp\\$$$$.dir" << endl;
	else
		setcd(argv[1]);

	return 0;
}
