{
	returncodes:
		0         : No error
		0 - 64800 : Time for execution in seconds (max. 18h)
		65530     : User break
		65531     : Error executing command.com
}

{$M 8192,0,0}
program
	timex;
uses
	dos,
	nya;
type
	string2				=	string[2];
const
	ver					:	string2 = '1';
	rev					:	string2 = '0';
	version				:	string[64] = '$VER: timex 1.0 (5.8.95) Copyright (C)1995-96 Fredrik Wangel';
var
	t1,
	m1,
	s1,
	h1,
	t2,
	m2,
	s2,
	h2						:	word;
	code					:	integer;
	time1,
	time2					:	longint;
	commandline			:	string;
	int1Bsave			:	pointer;

{$F+}
procedure _break_handler; interrupt;
	begin
		printstr('^C');
		setvector($1B, int1Bsave);
		halt(65530);
	end;
procedure Execute(cmd : string);
	var
		path			:	pathstr;
	begin
		{$I-}
		swapvectors;
		exec(getenv('COMSPEC'), '/C ' + cmd);
		swapvectors;
		if doserror <> 0 then begin
			path := fsearch('COMMAND.COM', getenv('PATH'));
			swapvectors;
			exec(fexpand(path), '/C ' + cmd);
			swapvectors;
			if doserror = 0 then begin
				if dosexitcode = 1 then begin
					setvector($1B, int1Bsave);
					halt(65530);
				end;
			end
			else begin
				printstrln('timex error: could not execute command.com');
				halt(65531);
			end;
		end
		else begin
			if dosexitcode = 1 then begin
				setvector($1B, int1Bsave);
				halt(65530);
			end;
		end;
	end;
FUNCTION CursX : Byte ; ASSEMBLER;
	ASM
		MOV	AX,0300h				(* Get Cursor Position *)
		MOV	BH,0					(* Page number *)
		INT	10h
		INC	DL
		MOV	AL, DL
	END;
FUNCTION CursY : Byte ; ASSEMBLER;
	ASM
		MOV	AX,0300h				(* Get Cursor Position *)
		MOV	BH,0					(* Page number *)
		INT	10h
		INC	DH
		MOV	AL, DH
	END;
function Pad(i : word) : string2;
	var
		s		:	string2;
	begin
		str (i, s);
		if length(s) = 1 then s := '0' + s;
		pad := s;
	end;

begin
	getvector($1B, int1Bsave);
	setvector($1B, addr(_break_handler));
	if (paramcount = 0) or (paramstr(1) = '/?') then begin
		printstrln('TimeX v' + ver + '.' + rev + ' (C)1995-96 Fredrik Wangel');
		printstrln('Usage: TimeX program [parameters]');
		setvector($1B, int1Bsave);
		halt(0);
	end;
	if paramstr(1) = '/!' then begin
		printstrln('         TimeX v' + ver + '.' + rev + ' (C)1995-96 Fredrik Wangel');
		printstrln('');
		printstrln('TimeX outputs the  time it takes to execute a program.');
		printstrln('You can  test how  long it took  (in seconds) by using');
		printstrln('the  ERRORLEVEL  function  in a batchfile.  The result');
		printstrln('will be  65530  if the user  interrupted  the program.');
		printstrln('You can redirect  the output using the standard MS-DOS');
		printstrln('output redirection character ( > ).  For  instance  to');
		printstrln('output to the printer you would type "TIMEX dir >prn".');
		printstrln('');
		setvector($1B, int1Bsave);
		halt(0);
	end;
	commandline := paramstr(1) + ' ';
	t2 := paramcount;
	for t1 := 2 to t2 do begin
		commandline := commandline + paramstr(t1) + ' ';
	end;
	commandline[0] := chr(length(commandline) - 1);
	XGetTime(t1, m1, s1, h1);
	Execute(commandline);
	XGetTime(t2, m2, s2, h2);

	if t1 > t2 then
		t1 := 24 - t1 + t2
	else
		t1 := abs(t2 - t1);

	if m1 > m2 then begin
		m1 := 60 - m1 + m2;
		t1 := t1 - 1;
	end
	else
		m1 := abs(m2 - m1);

	if s1 > s2 then begin
		s1 := 60 - s1 + s2;
		m1 := m1 - 1;
	end
	else
		s1 := abs(s2 - s1);

	if h1 > h2 then begin
		h1 := 100 - h1 + h2;
		s1 := s1 - 1;
	end
	else
		h1 := abs(h2 - h1);

	if m1 < 0 then begin
		m1 := 60 + m1;
		t1 := t1 - 1;
	end;
	if t1 < 0 then
		t1 := 24 - t1;

	val(pad(t1) + pad(m1) + pad(s1) + pad(h1), time1, code);
	str(time1, commandline);
	while length(commandline) < 8 do commandline := '0' + commandline;
	insert('.', commandline, 7);
	insert(':', commandline, 5);
	insert(':', commandline, 3);
	if cursx <> 1 then printstrln('');
	printstrln(commandline);
	setvector($1B, int1Bsave);
	time1 := time1 div 100;
	if time1 < 64800 then halt(word(time1));
end.
