{
	returncodes:
		0         : No error
		1         : User break
}

{$M 65520,0,16384}
program
	wherex;
uses
	crt,
	dos,
	nya,
	intl;
type
	OutProc				=	procedure(s: string);
	string2				=	string[2];
	string128			=	string[128];
const
	ver					:	string2 = '1';
	rev					:	string2 = '2';
	version				:	string[64] = '$VER: wherex 1.2 (21.02.96) Copyright (C)1996 Fredrik Wangel';
var
	Out,
	OutLn					:	OutProc;
	OldExit,
	int1Bsave			:	pointer;
	oldTA,
	i						:	integer;
	total					:	longint;
	parstr1				:	string;
	good,
	stopit				:	boolean;

procedure __write(s : string);
begin
	write(s);
end;

procedure __writeln(s : string);
begin
	writeln(s);
end;

function SetDeviceRaw(var T: Text) : boolean; assembler;
{ Checks whether or not the Text file is a device.
  If so, it is forced to "raw" mode }
asm
	LES	DI,T
	MOV	BX,WORD PTR ES:[DI]
	MOV	AX,4400H
	INT	21H
	MOV	AL, 0						{ assume false }
	TEST	DX,0080H
	JZ		@@1
	OR		DL,20H
	MOV	DH,DH
	MOV	AX,4401H
	INT	21H
	MOV	AL, 1						{ it was forced to raw }
@@1:
end;

procedure CursOff; assembler;
	asm
		mov	ah, 1
		mov	cx, 0ffffh
		int	10h
	end;

procedure CursOn; assembler;
	asm
		mov	ah, 1
		mov	cx, windmax
		shr	cx, 8
		cmp	cx, 25
		jge 	@a
		mov	cx, 100eh
		jmp	@b
@a:	mov	cx, 0806h
@b:	int	10h
	end;

{$F+}
procedure _break_handler; interrupt;
	begin
		out('^C');
		halt(1);
	end;

{$F+}
procedure NewExitProc;
begin
	ExitProc := OldExit;
	if ErrorAddr <> NIL then begin
		if ExitCode = 202 then begin
			OutLn('');
			OutLn('*** Oooops! Stack Overflow! ***');
		end
		else
			Out('Unexpected ');
	end;
	SetVector($1B, Int1Bsave);
	TextAttr := OldTA;
	Out(' '#13);
	FlushKbd;
	while keyhit do;
	FlushKbd;
	curson;
end;

FUNCTION LZ(W : LONGINT; B : BYTE) : STRING;
	VAR
		S	:	STRING[12];
	BEGIN
		STR(W : 0, S);
		WHILE LENGTH(S) < B DO S := ' ' + S;
		LZ := S;
	END;

FUNCTION PAD(S : STRING; B : BYTE) : STRING;
	BEGIN
		WHILE LENGTH(S) < B DO S := S + ' ';
		PAD := S;
	END;

function short(t : string ; mdl : byte) : string;
	var
		t2		:	string;
		ps,
		l		:	integer;
	begin
		l := length(t);
		if l > mdl then begin
			t[3] := #1;
			t2 := Copy(t, 4, Pos('\', t) - 3);
			repeat
				ps := Pos('\', t);
				Delete(t, 4, ps - 3);
			until (length(t) + 4 + length(t2)) <= mdl;
			t[3] := '\';
			insert(t2 + '...\', t, 4);
		end;
		short := t;
	end;

function findit(namn: string) : longint;
var
	key		: word;
	dirinfo	: searchrec;
	files		: longint;
	fp			: namestr;
	ep			: extstr;
	dp			: dirstr;

	procedure walktree(name: string128; var di: searchrec);
	var
		aaa,
		ndi	:	searchrec;
	begin
		if length(name) > 110 then begin
			outln('');
			outln('*** CAN NOT SEARCH AT DEEPER LEVELS ***');
			exit;
		end;
		if @out = @__write then begin
			out(#13 + short(name, 60));
			ClrEol;
		end;
		{$I-}
		findfirst(name + namn, Archive + ReadOnly + Hidden + SysFile, aaa);
		if doserror = 0 then begin
			if @out = @__write then begin
				textattr := white;
				outln(#13 + short(name, 60));
				textattr := oldTA;
			end
			else
				outln(name);
		end;
		while((doserror = 0) and (stopit = false)) do begin
			inc(files);
			outln('   ' + pad(lcasestrintl(aaa.name), 12) + '     ' + lz(aaa.size, 10) + ' bytes');
			if KeyHit then begin
				GetKey(key);
				FlushKbd;
			end;
			if hi(key) = $01 then
				stopit := true;
			{$I-}
			findnext(aaa);
		end;
		doserror := 0;
		{$I-}
		findfirst(name + '*.*', AnyFile, di);
		while ((doserror = 0) and (stopit = false)) do begin
			if (di.attr and directory) <> 0 then begin
				if (di.name <> '.') and (di.name <> '..') then begin
					ndi := di;
					walktree(name + di.name + '\', ndi);
				end;
			end;
			if KeyHit then begin
				GetKey(key);
				FlushKbd;
			end;
			if hi(key) = $01 then
				stopit := true;
			{$I-}
			findnext(di);
		end;
		if stopit = true then begin
			good := false;
		end;
	end;

	begin
		good   := true;
		stopit := false;
		files  := 0;
		key    := $0000;
		fsplit(namn, dp, fp, ep);
		if dp = '' then
			dp := '\';
		dp := fexpand(dp);
		namn := fp + ep;
		namn := ucasestr(namn);
		dp := ucasestr(dp);
		walktree(dp, dirinfo);
		if @out = @__write then begin
			Out(#13);
			ClrEol;
		end;
		if doserror = 3 then
			if @out = @__write then begin
				Out(#13'path "' + short(dp, 40) + '" not found');
				ClrEol;
			end;
		if not good then
			outln(#13'***Interrupted');
		outln('');
		findit := files;
	end;

begin
	getvector($1B, int1Bsave);
	setvector($1B, addr(_break_handler));
	OldExit := ExitProc;
	ExitProc := @NewExitProc;
	oldTA := textattr;
	textattr := lightgray;

	cursoff;

	if SetDeviceRaw(output) then begin
		Out   := __write;
		OutLn := __writeln;
	end
	else begin
		Out   := PrintStr;
		OutLn := PrintStrLn;
	end;

	if (paramcount = 0) or (paramstr(1) = '/?') then begin
		outln('WhereX v' + ver + '.' + rev + ' (C)1996 Fredrik Wangel');
		outln('Usage: WhereX files [/!]');
		halt(0);
	end;
	if paramstr(1) = '/!' then begin
		outln('WhereX searches for all files matching FILES. FILES can');
		outln('include  wildcards and also  be many  separate patterns');
		outln('If a path is  included the search  will  start in there');
		outln('eg C:\DOS\WHEREX c:\prog\pas\a*.pas *.bat d:\prog\c\*.h');
		outln('Otherwise it begins the search at the root of the drive');
		outln('You can redirect  the output using  the standard MS-DOS');
		outln('output redirection  character ( > ).  For  instance  to');
		outln('output to the printer you would type  "WHEREX *.h >prn"');
		halt(0);
	end;
	total := 0;
	for i := 1 to paramcount do begin
		parstr1 := paramstr(i);
		inc(total, FindIt(parstr1));
		if not good then
			break;
	end;
	outln('Found: ' + lz(total, 0) + ' matching files.');
end.
